* This script handles the ADO Connection and uses a CursorAdapter object
* to retrieve data to a cursor.

PUBLIC oCA as CursorAdapter
LOCAL oConn as ADODB.Connection
LOCAL oRS as ADODB.Recordset
LOCAL oException AS Exception
LOCAL cConnString

* Handle connections - insert connection code
myfile = GETFILE("MDB")
IF .NOT. FILE(MYFILE) .OR. EMPTY(MYFILE)
RETURN
ENDIF
cConnString = [Provider=MSDASQL.1;Persist Security Info=False;Extended Properties="dsn=MS Access Database;uid=";Initial Catalog=&myfile]
TRY 
    oConn  = createobject('ADODB.Connection')

    * Ensure that you handle userid and password if not 
    * specified in connection string.
    *   ex. oConn.Open(cConnString, userid, password)
    oConn.Open(cConnString)

    oRS = CREATEOBJECT("ADODB.Recordset")
    oRS.DataSource.CursorLocation = 3   &&adUseClient
    oRS.DataSource.LockType = 3   &&adLockOptimistic
    oRS.ActiveConnection = oConn

    oCA=CREATEOBJECT("CursorAdapter")
    oCA.DataSourceType = "ADO"
    oCA.DataSource = oRS
    oCA.MapBinary = .T.
    oCA.MapVarchar = .T.

    oCA.Alias = "MainTable"
    oCA.SelectCmd = "SELECT * FROM MainTable" 
      
    IF !oCA.CursorFill()
        * Replace with error code here
        LOCAL laError
        DIMENSION laError[1]
        AERROR(laError)
        MESSAGEBOX(laError[2])
    ELSE
        * Replace with user code here. Code below allows for
        * you to edit and send updates to the backend.
        LOCAL laFlds,lcStr,lnFldCount,i
        DIMENSION laFlds[1]
        lnFldCount=AFIELDS(laFlds)
        lcStr=""
        FOR i = 1 TO lnFldCount
                lcStr = lcStr + laFlds[m.i,1] +  ","
        ENDFOR
        oCA.UpdatableFieldList = lcStr
        MYALIAS = ALIAS()
        SCAN
        SELECT STUDENT
        IF RECCOUNT()<30 .OR. COPY_TEST = .F.
        APPEND BLANK 
        MYSSN = ALLTRIM(STR(RECNO())) 
        MYSSN = REPLICATE("0",4-LEN(MYSSN)) + MYSSN
        FOR SV1 = 1 TO 4
        MYADD = ALLTRIM(STR(INT(RAND()*100))) 
        IF LEN(MYADD) = 2
        MYSSN = MYADD + MYSSN
        ENDIF
        IF LEN(MYADD) = 1
        MYSSN = "7"+ MYADD + MYSSN
        ENDIF
        IF LEN(MYADD) = 0
        MYSSN = "59" + MYSSN
        ENDIF
        NEXT
        IF LEFT(MYSSN,1) = "0"
        MYSSN = "9" + SUBSTR(MYSSN,2)
        ENDIF
        MYSSN = SUBSTR(MYSSN,1,2)+SUBSTR(MYSSN,9,1)+;
        SUBSTR(MYSSN,3,2)+SUBSTR(MYSSN,10,1)+;
        SUBSTR(MYSSN,5,3)+SUBSTR(MYSSN,11,1)+;
        SUBSTR(MYSSN,8,1)+SUBSTR(MYSSN,12,1)
        MYSSN = REPLICATE("3",12-LEN(MYSSN)) + MYSSN
        MYSSN = VAL(MYSSN)
        REPLACE F_SSN WITH MYSSN 
        REPLACE F_STDID WITH  &MYALIAS->StID 
        *REPLACE F_SYSID WITH &MYALIAS -> SYSTEMID
        REPLACE F_NAME WITH &MYALIAS -> Name
        *REPLACE F_SEX WITH &MYALIAS -> SEX
        REPLACE F_QSTATUS WITH &MYALIAS -> CASE
        ENDIF
        SELECT (MYALIAS)
        ENDSCAN
        MESSAGEBOX("   ",0," ")
    ENDIF

CATCH TO oException
    * Replace with exception handling code here
    MESSAGEBOX("oh not",0,"wow")
    MESSAGEBOX(oException.Message)
ENDTRY

* Add user code here.
* Note: cursors created by CursorAdapter object are closed when object is released.
